/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.7 by edhill, Mon Sep 22 19:06:12 2003 UTC revision 1.67 by adcroft, Tue Feb 24 19:00:32 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20    }
21    
22    # Search for particular CPP #cmds associated with MPI
23    # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24    test_for_mpi_in_cpp_eeoptions() {
25        cpp_options=$1
26        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38        RETVAL=$?
39        if test "x${RETVAL}" = x0 ; then
40            echo -n "Error: In $file there is an illegal line: "
41            grep -i "$strng" $file
42            return 1
43        fi
44        return 0
45    }
46    
47    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
48    # the package list.
49    expand_pkg_groups() {
50        new_packages=
51        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
52        if test -r $PKG_GROUPS ; then
53            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
54            cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
55            matched=0
56            for i in $PACKAGES ; do
57                line=`grep "^ *$i" ./p2.tmp`
58                RETVAL=$?
59                if test "x$RETVAL" = x0 ; then
60                    matched=1
61                    replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
62                    echo "    replacing \"$i\" with: $replace"
63                    new_packages="$new_packages $replace"
64                else
65                    new_packages="$new_packages $i"
66                fi
67            done
68            PACKAGES=$new_packages
69            rm -f ./p[1,2].tmp
70        else
71            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
72        fi
73    }
74    
75  # Guess possible config options for this host  # Guess possible config options for this host
76  find_possible_configs()  {  find_possible_configs()  {
77    
78      p_PLATFORM=`uname`"-"`uname -m`      tmp1=`uname`"_"`uname -m`
79      echo "The platform appears to be:"      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      echo "  "$p_PLATFORM      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82      p_LN=      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84        OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85        echo "  The platform appears to be:  $PLATFORM"
86        
87      echo "test" > test      echo "test" > test
88      ln -s ./test link      ln -s ./test link
89      RETVAL=$?      RETVAL=$?
90      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
91          p_LN="ln -s"          LN="ln -s"
92        else
93            echo "Error: \"ln -s\" does not appear to work on this system!"
94            echo "  For help, please contact <MITgcm-support@mitgcm.org>."
95            exit 1
96      fi      fi
97      rm -f test link      rm -f test link
98    
99      p_CPP=`which cpp`      if test "x$CPP" = x ; then
100                CPP="cpp -traditional -P"
101      RETVAL=$?      fi
102      if test "x${RETVAL}" = x0 ; then  
103          p_LN="ln -s"      # makedepend is not always available
104        if test "x${MAKEDEPEND}" = x ; then
105          which makedepend >& /dev/null
106          RETVAL=$?
107          if test "x${RETVAL}" = x1 ; then
108             echo "    makedepend was not found. Using xmakedpend instead."
109             MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
110          fi
111      fi      fi
     rm -f test link  
112    
113      # look for possible fortran compilers      # look for possible fortran compilers
114        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
115      p_FC=      p_FC=
116      for c in f77 g77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 ; do      for c in $tmp ; do
117          which $c > /dev/null 2>&1          rm -f ./hello.f ./hello
118            cat >> hello.f <<EOF
119          program hello
120          do i=1,3
121            print *, 'hello world : ', i
122          enddo
123          end
124    EOF
125            $c -o hello hello.f > /dev/null 2>&1
126          RETVAL=$?          RETVAL=$?
127          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
128              p_FC="$p_FC $c"              p_FC="$p_FC $c"
129          fi          fi
130      done      done
131      echo "Possible FORTRAN compilers appear to be:  "      rm -f ./hello.f ./hello
132      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
133          echo "  None found!!!"          cat 1>&2 <<EOF
134    
135    Error: No Fortran compilers were found in your path.  Please specify one using:
136    
137        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
138        2) a command-line option (eg. "-fc NAME"), or
139        3) the MITGCM_FC environment variable.
140    
141    EOF
142            exit 1
143      else      else
144          echo "  "$p_FC          echo "  The possible FORTRAN compilers found in your path are:"
145            echo "   "$p_FC
146            if test "x$FC" = x ; then
147                FC=`echo $p_FC | $AWK '{print $1}'`
148                echo "  Setting FORTRAN compiler to: "$FC
149            fi
150      fi      fi
151    
152      # look for possible MPI libraries      if test "x$OPTFILE" = x ; then
153      mpi_libs=          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
154      mpi_fort=`which mpif77 2>/dev/null`          if test ! -r $OPTFILE ; then
155      RETVAL=$?               echo "  I looked for the file "$OPTFILE" but did not find it"
156      if test "x${RETVAL}" = x0 ; then          fi
157          cat >>test.f <<EOF      fi
158        PROGRAM HELLO  #    echo "  The options file:  $p_OF"
159        DO 10, I=1,10  #    echo "    appears to match so we'll use it."
160        PRINT *,'Hello World'  #   for i in $p_FC ; do
161     10 CONTINUE  #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
162        STOP  #if test -r $p_OF ; then
163        END  #    OPTFILE=$p_OF
164    #    echo "  The options file:  $p_OF"
165    #    echo "    appears to match so we'll use it."
166    #    break
167    #fi
168    #   done
169        if test "x$OPTFILE" = x ; then
170            cat 1>&2 <<EOF
171    
172    Error: No options file was found in:  $ROOTDIR/tools/build_options/
173      that matches this platform ("$PLATFORM") and the compilers found in
174      your path.  Please specify an "optfile" using:
175    
176        1) the command line (eg. "-optfile=path/to/OPTFILE"), or
177        2) the MITGCM_OF environment variable.
178    
179      If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
180    
181  EOF  EOF
182          eval "$mpi_fort -showme test.f > out"          exit 1
         RETVAL=$?  
         if test "x${RETVAL}" = x0 ; then  
             a=`cat out`  
             for i in $a ; do  
                 case $i in  
                     -*)  
                         mpi_libs="$mpi_libs $i" ;;  
                 esac  
             done  
             echo "The MPI libs appear to be:"  
             echo "  "$mpi_libs  
         fi  
         rm -f test.f out  
183      fi      fi
184        
185    #     # look for possible MPI libraries
186    #     mpi_libs=
187    #     mpi_fort=`which mpif77 2>/dev/null`
188    #     RETVAL=$?
189    #     if test "x${RETVAL}" = x0 ; then
190    #       cat >>test.f <<EOF
191    #       PROGRAM HELLO
192    #       DO 10, I=1,10
193    #       PRINT *,'Hello World'
194    #    10 CONTINUE
195    #       STOP
196    #       END
197    # EOF
198    #       eval "$mpi_fort -showme test.f > out"
199    #       RETVAL=$?
200    #       if test "x${RETVAL}" = x0 ; then
201    #           a=`cat out`
202    #           for i in $a ; do
203    #               case $i in
204    #                   -*)
205    #                       mpi_libs="$mpi_libs $i" ;;
206    #               esac
207    #           done
208    #           echo "The MPI libs appear to be:"
209    #           echo "  "$mpi_libs
210    #       fi
211    #       rm -f test.f out
212    #     fi
213    
214  }  }
215    
# Line 86  get_pdepend_list()  { Line 219  get_pdepend_list()  {
219      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
220      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
221      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
222          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
223          > ./.pd_tmp          > ./.pd_tmp
224      source ./.pd_tmp      . ./.pd_tmp
225      rm -f ./.pd_tmp      rm -f ./.pd_tmp
226    
227      echo -n "PNAME = "${}      echo -n "PNAME = "${}
# Line 97  get_pdepend_list()  { Line 230  get_pdepend_list()  {
230    
231  #  Explain usage  #  Explain usage
232  usage()  {  usage()  {
233      echo  cat <<EOF
234      echo "Usage: "$0" [OPTIONS]"  
235      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
236      echo    where [OPTIONS] can be:
237      echo "    -help | --help | -h | --h"  
238      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
239      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
240      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
241      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
242      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
243      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
244      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
245      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
246      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
247      echo "    -makefile NAME | -mf NAME"  
248      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
249      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
250      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
251      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
252      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
253      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
254      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
255      echo "    -disable NAME | --disable NAME"  
256      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
257      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
258      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
259      echo "    -noopt NAME | --noopt NAME"            many platforms, "gmake" is the preferred choice.
260      echo "      -noopt=NAME | --noopt=NAME"  
261  #    echo "    -cpp NAME | --cpp NAME"      -makefile NAME | -mf NAME
262  #    echo "      -cpp=NAME | --cpp=NAME"        --makefile=NAME | -mf=NAME
263      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"            Call the makefile "NAME".  The default is "Makefile".
264      echo "      -fc=NAME | --fc=NAME"  
265      echo "    -[no]ieee | --[no]ieee"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
266      echo "    -[no]mpi | --[no]mpi"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
267      echo "    -[no]jam | --[no]jam"            Specify the location of the MITgcm ROOTDIR as "NAME".
268      echo            By default, genamke will try to find the location by
269      echo "  and NAME is a string such as:"            looking in parent directories (up to the 5th parent).
270      echo  
271      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
272      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
273      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"            Here, "NAME" specifies a list of directories that are
274      echo            used for additional source code.  Files found in the
275      echo "  which, depending upon your shell, may need to be single-quoted"            "mods list" are given preference over files of the same
276      echo "  if it contains spaces, dashes, or other special characters."            name found elsewhere.
277    
278        -disable NAME | --disable NAME
279          -disable=NAME | --disable=NAME
280              Here "NAME" specifies a list of packages that we don't
281              want to use.  If this violates package dependencies,
282              genamke will exit with an error message.
283    
284        -enable NAME | --enable NAME
285          -enable=NAME | --enable=NAME
286              Here "NAME" specifies a list of packages that we wish
287              to specifically enable.  If this violates package
288              dependencies, genamke will exit with an error message.
289    
290        -standarddirs NAME | --standarddirs NAME
291          -standarddirs=NAME | --standarddirs=NAME
292              Here, "NAME" specifies a list of directories to be
293              used as the "standard" code.
294    
295        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
296          -fc=NAME | --fc=NAME
297              Use "NAME" as the fortran compiler.  By default, genmake
298              will search for a working compiler by trying a list of
299              "usual suspects" such as g77, f77, etc.
300    
301        -[no]ieee | --[no]ieee
302              Do or don't use IEEE numerics.  Note that this option
303              *only* works if it is supported by the OPTFILE that
304              is being used.
305    
306        -mpi | --mpi
307              Include MPI header files and link to MPI libraries
308        -mpi=PATH | --mpi=PATH
309              Include MPI header files and link to MPI libraries using MPI_ROOT
310              set to PATH. i.e. Include files from $PATH/include, link to libraries
311              from $PATH/lib and use binaries from $PATH/bin.
312    
313      While it is most often a single word, the "NAME" variables specified
314      above can in many cases be a space-delimited string such as:
315    
316        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
317        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
318        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
319    
320      which, depending upon your shell, may need to be single-quoted.
321    
322      For more detailed genmake documentation, please see:
323    
324        http://mitgcm.org/devel_HOWTO/
325    
326    EOF
327    
328      exit 1      exit 1
329  }  }
330    
331  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
332  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
333  #eh3 set CPP        = ( '/lib/cpp -P' )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
334  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      
335  #eh3 set KPP        = (  )      cat > genmake_test.c <<EOF
336  #eh3 set FC         = ( 'f77' )  void tcall( char * string ) { tsub( string ); }
337  #eh3 set LINK       = $FC  EOF
338  #eh3 set MAKEDEPEND = ( 'makedepend' )      $MAKE genmake_test.o >> genmake_warnings 2>&1
339  #eh3 set INCLUDES   = ( -I. )      RETVAL=$?
340  #eh3 set FFLAGS     = (  )      if test "x$RETVAL" != x0 ; then
341  #eh3 set FOPTIM     = (  )          FC_NAMEMANGLE=$default_nm
342  #eh3 set CFLAGS     = (  )          cat <<EOF>> genmake_errors
343  #eh3 set KFLAGS1    = (  )  
344  #eh3 set KFLAGS2    = (  )  WARNING: C test compile fails
345  #eh3 set LIBS       = (  )  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
346  #eh3 set KPPFILES   = (  )  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
347  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )  EOF
348  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          return 1
349        fi
350        c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
351        RETVAL=$?
352        if test "x$RETVAL" != x0 ; then
353            FC_NAMEMANGLE=$default_nm
354            cat <<EOF>> genmake_warnings
355    
356    WARNING: The "nm" command failed.
357    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
358    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
359    EOF
360            return 1
361        fi
362        cat > genmake_tcomp.f <<EOF
363          subroutine tcall( string )
364          character*(*) string
365          call tsub( string )
366          end
367    EOF
368        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
369        RETVAL=$?
370        if test "x$RETVAL" != x0 ; then
371            FC_NAMEMANGLE=$default_nm
372            cat <<EOF>> genmake_warnings
373    
374    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
375    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
376    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
377    EOF
378            return 1
379        fi
380        f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
381        RETVAL=$?
382        if test "x$RETVAL" != x0 ; then
383            FC_NAMEMANGLE=$default_nm
384            cat <<EOF>> genmake_warnings
385    
386    WARNING: The "nm" command failed.
387    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
388    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
389    EOF
390            return 1
391        fi
392    
393        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
394        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
395        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
396        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
397    
398        nmangle="X"
399        if test "x$c_a" != "x$f_a" ; then
400            comm="echo x$f_a | sed -e 's|x$c_a||'"
401            a=`eval $comm`
402            nmangle="$a ## $nmangle"
403        fi
404        if test "x$c_b" != "x$f_b" ; then
405            comm="echo x$f_b | sed -e 's|x$c_b||'"
406            b=`eval $comm`
407            nmangle="$nmangle ## $b"
408        fi
409    
410        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
411    
412        #  cleanup the testing files
413        rm -f genmake_tcomp.* genmake_test.*
414    }
415    
416    
417    check_HAVE_CLOC()  {
418        get_fortran_c_namemangling
419        cat <<EOF > genmake_tc_1.c
420    $FC_NAMEMANGLE
421    #include <stdio.h>
422    #include <stdlib.h>
423    #include <unistd.h>
424    #include <assert.h>
425    #include <sys/time.h>
426    void FC_NAMEMANGLE(cloc) ( double *curtim )
427    {
428     struct timeval tv1;
429     gettimeofday(&tv1 , (void *)NULL );
430     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
431     *curtim = *curtim/1.E6;
432    }
433    EOF
434        make genmake_tc_1.o >> genmake_tc.log 2>&1
435        RET_C=$?
436        cat <<EOF > genmake_tc_2.f
437          program hello
438          Real*8 wtime
439          external cloc
440          call cloc(wtime)
441          print *," HELLO WORLD", wtime
442          end program hello
443    EOF
444        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
445        RET_F=$?
446        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
447        RETVAL=$?
448        if test "x$RETVAL" = x0 ; then
449            HAVE_CLOC=t
450            DEFINES="$DEFINES -DHAVE_CLOC"
451        fi
452        rm -f genmake_tc*
453    }
454    
455    
456    check_netcdf_libs()  {
457        cat <<EOF > genmake_tnc.F
458          program fgennc
459    #include "netcdf.inc"
460          integer iret, ncid, xid
461          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
462          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
463          iret = nf_def_dim(ncid, 'X', 11, xid)
464          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
465          iret = nf_close(ncid)
466          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
467          end
468    EOF
469        $CPP genmake_tnc.F > genmake_tnc.f  \
470            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
471        RET_COMPILE=$?
472        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
473        RETVAL=$?
474        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
475            HAVE_NETCDF=t
476        else
477            # try again with "-lnetcdf" added to the libs
478            $CPP genmake_tnc.F > genmake_tnc.f  \
479                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
480                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
481            RET_COMPILE=$?
482            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
483            RETVAL=$?
484            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
485                LIBS="$LIBS -lnetcdf"
486                HAVE_NETCDF=t
487            else
488                cat genmake_tnc.log >> genmake_warnings
489            fi
490        fi
491        rm -f genmake_tnc*
492    }
493    
494    
495    
496    ###############################################################################
497    #   Sequential part of script starts here
498    ###############################################################################
499    
500  #  Set defaults here  #  Set defaults here
501  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 171  LN= Line 505  LN=
505  S64=  S64=
506  KPP=  KPP=
507  FC=  FC=
508    CPP=
509  LINK=  LINK=
510    DEFINES=
511  PACKAGES=  PACKAGES=
512  ENABLE=  ENABLE=
513  DISABLE=  DISABLE=
514  MAKEFILE=  MAKEFILE=
515  MAKEDEPEND=  MAKEDEPEND=
516  PDEPEND=  PDEPEND=
517  DUMPSTATE=f  DUMPSTATE=t
518  PDEFAULT=  PDEFAULT=
519  OPTFILE=  OPTFILE=
520  INCLUDES="-I."  INCLUDES="-I."
# Line 191  LIBS= Line 527  LIBS=
527  KPPFILES=  KPPFILES=
528  NOOPTFILES=  NOOPTFILES=
529  NOOPTFLAGS=  NOOPTFLAGS=
530    MPI=
531    MPIPATH=
532    
533    # DEFINES checked by test compilation
534    HAVE_SYSTEM=
535    HAVE_FDATE=
536    FC_NAMEMANGLE=
537    HAVE_CLOC=
538    HAVE_NETCDF=
539    
540  MODS=  MODS=
541  TOOLSDIR=  TOOLSDIR=
542  SOURCEDIRS=  SOURCEDIRS=
543  INCLUDEDIRS=  INCLUDEDIRS=
544    STANDARDDIRS="USE_THE_DEFAULT"
545    
546  PWD=`pwd`  PWD=`pwd`
547  MAKE=make  MAKE=make
548    AWK=awk
549  THISHOSTNAME=`hostname`  THISHOSTNAME=`hostname`
550  THISCWD=`pwd`  THISCWD=`pwd`
551  THISDATE=`date`  THISDATE=`date`
# Line 206  MACHINE=`uname -a` Line 553  MACHINE=`uname -a`
553  EXECUTABLE=  EXECUTABLE=
554  EXEHOOK=  EXEHOOK=
555  EXEDIR=  EXEDIR=
556    PACKAGES_CONF=
557    IEEE=
558    if test "x$MITGCM_IEEE" != x ; then
559        IEEE=$MITGCM_IEEE
560    fi
561    
562    AUTODIFF_PKG_USED=f
563    AD_OPTFILE=
564    TAF=
565    AD_TAF_FLAGS=
566    FTL_TAF_FLAGS=
567    SVD_TAF_FLAGS=
568    TAF_EXTRA=
569    TAMC=
570    AD_TAMC_FLAGS=
571    FTL_TAF_FLAGS=
572    SVD_TAMC_FLAGS=
573    TAMC_EXTRA=
574    
575    
576  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
577  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
578  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
579    
580  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
581  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
582  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
583  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
584  gm_s6="EXECUTABLE EXEHOOK EXEDIR"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
585    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
586    
587  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
588    gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
589    gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
590    gm_s12="TAF_EXTRA TAMC_EXTRA"
591    
592    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
593    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
594    
595    cat <<EOF
596    
597    GENMAKE :
598    
599    A program for GENerating MAKEfiles for the MITgcm project.  For a
600    quick list of options, use "genmake -h" or for more detail see:
601    
602      http://mitgcm.org/devel_HOWTO/
603    
604    EOF
605    
 echo  
606  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
607  gm_local="./gm_local"  gm_local="genmake_local"
608    for i in . $MODS ; do
609        if test -r $i/$gm_local ; then
610            . $i/$gm_local
611            break
612        fi
613    done
614  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
615  if test -e $gm_local ; then  if test -e $gm_local ; then
616      echo "using $gm_local"      echo "using $gm_local"
617      source $gm_local      . $gm_local
618      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
619      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
620  else  else
# Line 244  fi Line 632  fi
632  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
633  #done  #done
634  #parse_options  #parse_options
   
635  ac_prev=  ac_prev=
636  for ac_option ; do  for ac_option ; do
637    
# Line 269  for ac_option ; do Line 656  for ac_option ; do
656          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
657              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
658                    
659            -adoptfile | --adoptfile | -adof | --adof)
660                ac_prev=AD_OPTFILE ;;
661            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
662                AD_OPTFILE=$ac_optarg ;;
663            
664          -pdepend | --pdepend)          -pdepend | --pdepend)
665              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
666          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 289  for ac_option ; do Line 681  for ac_option ; do
681          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
682              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
683                    
684          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
685              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
686          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
687              PLATFORM=$ac_optarg ;;              echo
688                usage
689                ;;
690                    
691          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
692              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 314  for ac_option ; do Line 708  for ac_option ; do
708          -enable=* | --enable=*)          -enable=* | --enable=*)
709              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
710                    
711          -noopt | --noopt)          -standarddirs | --standarddirs)
712              ac_prev=NOOPT ;;              ac_prev=STANDARDDIRS ;;
713          -noopt=* | --noopt=*)          -standarddirs=* | --standarddirs=*)
714              NOOPT=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
715            
716  #           -cpp | --cpp)  #           -cpp | --cpp)
717  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
718  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 330  for ac_option ; do Line 724  for ac_option ; do
724              FC=$ac_optarg ;;              FC=$ac_optarg ;;
725                    
726          -ieee | --ieee)          -ieee | --ieee)
727              IEEE=1 ;;              IEEE=true ;;
728          -noieee | --noieee)          -noieee | --noieee)
729              IEEE=0 ;;              IEEE= ;;
730            
731          -mpi | --mpi)          -mpi | --mpi)
732              MPI=1 ;;              MPI=true ;;
733          -nompi | --nompi)          -mpi=* | --mpi=*)
734              MPI=0 ;;              MPIPATH=$ac_optarg
735                MPI=true ;;
736                    
737          -jam | --jam)  #       -jam | --jam)
738              JAM=1 ;;  #           JAM=1 ;;
739          -nojam | --nojam)  #       -nojam | --nojam)
740              JAM=0 ;;  #           JAM=0 ;;
741                    
742          -ds | --ds)          -ds | --ds)
743              DUMPSTATE=t ;;              DUMPSTATE=t ;;
744                    
745            -taf_extra | --taf_extra)
746                ac_prev=TAF_EXTRA ;;
747            -taf_extra=* | --taf_extra=*)
748                TAF_EXTRA=$ac_optarg ;;
749    
750            -tamc_extra | --tamc_extra)
751                ac_prev=TAMC_EXTRA ;;
752            -tamc_extra=* | --tamc_extra=*)
753                TAMC_EXTRA=$ac_optarg ;;
754    
755          -*)          -*)
756              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
757              usage              usage
# Line 361  for ac_option ; do Line 766  for ac_option ; do
766            
767  done  done
768    
769    if test -f ./.genmakerc ; then
770        echo
771        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
772        echo "  file.  This file format is no longer supported.  Please see:"
773        echo
774        echo "    http://mitgcm.org/devel_HOWTO/"
775        echo
776        echo "  for directions on how to setup and use the new \"genmake2\" input"
777        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
778        echo
779    fi
780    
781    if test "x${ROOTDIR}" = x ; then
782        if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
783            ROOTDIR=".."
784        else
785            for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
786                if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
787                    ROOTDIR=$d
788                    echo -n "Warning:  ROOTDIR was not specified but there appears to be"
789                    echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
790                    break
791                fi
792            done
793        fi
794    fi
795    if test "x${ROOTDIR}" = x ; then
796        echo "Error: Cannot determine ROOTDIR for MITgcm code."
797        echo "  Please specify a ROOTDIR using either an options "
798        echo "  file or a command-line option."
799        exit 1
800    fi
801    if test ! -d ${ROOTDIR} ; then
802        echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
803        exit 1
804    fi
805    
806  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
807  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
808      echo "Warning: no OPTFILE specified so we'll look for possible settings"      if test "x$MITGCM_OF" = x ; then
809      printf "\n===  Searching for possible settings for OPTFILE  ===\n"          echo "Warning: no OPTFILE specified so we'll look for possible settings"
810      find_possible_configs          printf "\n===  Searching for possible settings for OPTFILE  ===\n"
811  else          find_possible_configs
     if test "x$OPTFILE" = xNONE ; then  
         echo "    OPTFILE=NONE so we'll try to use default settings"  
812      else      else
813          if test -f "$OPTFILE" -a -r "$OPTFILE" ; then          OPTFILE=$MITGCM_OF
814              echo "    using OPTFILE=\"$OPTFILE\""      fi
815              source "$OPTFILE"  fi
816              RETVAL=$?  if test "x$OPTFILE" != xNONE ; then
817              if test "x$RETVAL" != x0 ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
818                  echo -n "Error: failed to source OPTFILE \"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
819                  echo "--please check that variable syntax is bash-compatible"          . "$OPTFILE"
820                  exit 1          RETVAL=$?
821              fi          if test "x$RETVAL" != x0 ; then
822              if test "x$DUMPSTATE" != xf ; then              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
823                  cp -f $OPTFILE "gm_optfile"              echo "--please check that variable syntax is bash-compatible"
             fi  
         else  
             echo "Error: can't read OPTFILE=\"$OPTFILE\""  
824              exit 1              exit 1
825          fi          fi
826            if test "x$DUMPSTATE" != xf ; then
827                cp -f $OPTFILE "genmake_optfile"
828            fi
829        else
830            echo "Error: can't read OPTFILE=\"$OPTFILE\""
831            exit 1
832        fi
833    fi
834    
835    echo "  getting AD_OPTFILE information:  "
836    if test "x${AD_OPTFILE}" = x ; then
837        if test "x$MITGCM_AD_OF" = x ; then
838            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
839        else
840            AD_OPTFILE=$MITGCM_AD_OF
841      fi      fi
842  fi  fi
843    if test "x${AD_OPTFILE}" != xNONE ; then
844        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
845            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
846            . "$AD_OPTFILE"
847            RETVAL=$?
848            if test "x$RETVAL" != x0 ; then
849                echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
850                echo "--please check that variable syntax is bash-compatible"
851                exit 1
852            fi
853            if test "x$DUMPSTATE" != xf ; then
854                cp -f $AD_OPTFILE "genmake_ad_optfile"
855            fi
856        else
857            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
858            exit 1
859        fi
860    fi
861    
862    #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
863    #  either set defaults or complain and abort!
864    if test "x$FC" = x ; then
865        cat <<EOF 1>&2
866    
867    Error: no Fortran compiler: please specify using one of the following:
868      1) within the options file ("FC=...") as specified by "-of=OPTFILE"
869      2) the "-fc=XXX" command-line option
870      3) the "./genmake_local" file
871    EOF
872        exit 1
873    fi
874    if test "x$LINK" = x ; then
875        LINK=$FC
876    fi
877    if test "x$MAKE" = x ; then
878        MAKE="make"
879    fi
880    if test "x$CPP" = x ; then
881        CPP=cpp
882    fi
883    #EH3 === UGLY ===
884    #  The following an ugly little hack to check for $CPP in /lib/ and it
885    #  should eventually be replaced with a more general function that
886    #  searches a combo of the user's path and a list of "usual suspects"
887    #  to find the correct location for binaries such as $CPP.
888    for i in " " "/lib/" ; do
889        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
890    done
891    #EH3 === UGLY ===
892    echo "#define A a" | $CPP > test_cpp 2>&1
893    RETVAL=$?
894    if test "x$RETVAL" != x0 ; then
895        cat <<EOF 1>&2
896    
897    Error: C pre-processor "$CPP" failed the test case: please specify using:
898    
899      1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
900      2) the "./genmake_local" file
901      3) with the CPP environment variable
902    
903    EOF
904        exit 1
905    else
906        rm -f test_cpp
907    fi
908    if test "x$MAKEDEPEND" = x ; then
909        MAKEDEPEND=makedepend
910    fi
911    if test "x$LN" = x ; then
912        LN="ln -s"
913    fi
914    echo "test" > genmake_test_ln
915    $LN genmake_test_ln genmake_tlink
916    RETVAL=$?
917    if test "x$RETVAL" != x0 ; then
918        cat <<EOF 1>&2
919    
920    Error: The command "ln -s" failed -- please specify a working soft-link
921      command in the optfile.
922    
923    EOF
924        exit 1
925    fi
926    rm -f genmake_test_ln genmake_tlink
927    
928    if test ! "x$MPI" = x ; then
929          echo "  Turning on MPI cpp macros"
930          DEFINES="$DEFINS -DALLOW_USE_MPI -DALWAYS_USE_MPI"
931    fi
932    
933    printf "\n===  Checking system libraries  ===\n"
934    echo -n "  Do we have the system() command using $FC...  "
935    cat > genmake_tcomp.f <<EOF
936          program hello
937          call system('echo hi')
938          end
939    EOF
940    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
941    RETVAL=$?
942    if test "x$RETVAL" = x0 ; then
943        HAVE_SYSTEM=t
944        DEFINES="$DEFINES -DHAVE_SYSTEM"
945        echo "yes"
946    else
947        HAVE_SYSTEM=
948        echo "no"
949    fi
950    rm -f genmake_tcomp*
951    
952    echo -n "  Do we have the fdate() command using $FC...  "
953    cat > genmake_tcomp.f <<EOF
954          program hello
955          CHARACTER(128) string
956          string = ' '
957          call fdate( string )
958          print *, string
959          end
960    EOF
961    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
962    RETVAL=$?
963    if test "x$RETVAL" = x0 ; then
964        HAVE_FDATE=t
965        DEFINES="$DEFINES -DHAVE_FDATE"
966        echo "yes"
967    else
968        HAVE_FDATE=
969        echo "no"
970    fi
971    rm -f genmake_tcomp*
972    
973    echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
974    check_HAVE_CLOC
975    if test "x$HAVE_CLOC" != x ; then
976        echo "yes"
977    else
978        echo "no"
979    fi
980    rm -f genmake_t*
981    
982    echo -n "  Can we create NetCDF-enabled binaries...  "
983    check_netcdf_libs
984    if test "x$HAVE_NETCDF" != x ; then
985        echo "yes"
986    else
987        echo "no"
988    fi
989    
990    
991  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
992  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
# Line 411  if test "x${PLATFORM}" = x ; then Line 1010  if test "x${PLATFORM}" = x ; then
1010      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1011  fi  fi
1012    
 if test "x${ROOTDIR}" = x ; then  
     if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then  
         ROOTDIR=".."  
     else  
         for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do  
             if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then  
                 ROOTDIR=$d  
                 echo -n "Warning:  ROOTDIR was not specified but there appears to be"  
                 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."  
                 break  
             fi  
         done  
     fi  
 fi  
 if test "x${ROOTDIR}" = x ; then  
     echo "Error: Cannot determine ROOTDIR for MITgcm code."  
     echo "  Please specify a ROOTDIR using either an options "  
     echo "  file or a command-line option."  
     exit 1  
 fi  
 if test ! -d ${ROOTDIR} ; then  
     echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"  
     exit 1  
 fi  
   
1013  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1014      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then
1015          EXEDIR=../exe          EXEDIR=../exe
# Line 452  if test "x${TOOLSDIR}" = x ; then Line 1026  if test "x${TOOLSDIR}" = x ; then
1026      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1027  fi  fi
1028  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1029      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1030      exit 1      exit 1
1031  fi  fi
1032    if test "x$S64" = x ; then
1033        S64='$(TOOLSDIR)/set64bitConst.sh'
1034    fi
1035    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1036    
1037  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1038    
# Line 463  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1041  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1041  #  they appear as regular source code  #  they appear as regular source code
1042  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1043      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1044      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1045      RETVAL=$?      RETVAL=$?
1046      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1047          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1048      else      else
1049          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1050          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1051          exit 1          exit 1
1052      fi      fi
1053  fi  fi
1054    
1055    #same for exch2
1056    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1057        echo "  Making source files in exch2 from  templates"
1058        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1059        RETVAL=$?
1060        if test "x${RETVAL}" = x0 ; then
1061            rm -f make_exch2.errors
1062        else
1063            echo "Error: problem encountered while building source files in exch2:"
1064            cat make_exch2.errors 1>&2
1065            exit 1
1066        fi
1067    fi
1068    
1069  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1070  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1071      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 493  echo "  getting package dependency info Line 1085  echo "  getting package dependency info
1085  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
1086  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
1087  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
1088      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1089      > ./.pd_tmp      > ./.pd_tmp
1090  RETVAL=$?  RETVAL=$?
1091  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
1092      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1093      exit 1      exit 1
1094  fi  fi
1095  source ./.pd_tmp  . ./.pd_tmp
1096  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1097    
1098  echo  -n "  checking default package list:  "  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1099    #  file should eventually be added so that, for convenience, one can
1100    #  specify groups of packages using names like "ocean" and "atmosphere".
1101    echo "  checking default package list:  "
1102    if test "x${PDEFAULT}" = x ; then
1103        for i in "." $MODS ; do
1104            if test -r $i"/packages.conf" ; then
1105                    PDEFAULT=$i"/packages.conf"
1106                    break
1107            fi
1108        done
1109    fi
1110  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1111      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1112  fi  fi
1113  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1114      echo "default packages file disabled"      echo "    default packages file disabled"
1115  else  else
1116      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1117          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1118      else      else
1119          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1120          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1121          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1122          RETVAL=$?          RETVAL=$?
1123          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1124              echo -n "Error: can't parse default package list "              echo -n "Error: can't parse default package list "
# Line 526  else Line 1128  else
1128          for i in $def ; do          for i in $def ; do
1129              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1130          done          done
1131          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1132            expand_pkg_groups
1133            echo "    after group expansion packages are:  $PACKAGES"
1134      fi      fi
1135  fi  fi
1136    
# Line 545  for p in $PACKAGES ; do Line 1149  for p in $PACKAGES ; do
1149  done  done
1150  PACKAGES="$pack"  PACKAGES="$pack"
1151  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1152  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
1153  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1154  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1155      if test ! -d "$ROOTDIR/pkg/$i" ; then      if test ! -d "$ROOTDIR/pkg/$i" ; then
# Line 636  for i in $PACKAGES ; do Line 1240  for i in $PACKAGES ; do
1240      if test -d $adr ; then      if test -d $adr ; then
1241          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
1242          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
1243            if test "x$i" = xautodiff ; then
1244                AUTODIFF_PKG_USED=t
1245            fi
1246      else      else
1247          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
1248          exit 1          exit 1
1249      fi      fi
1250  done  done
1251    
1252  #  This is compatible with the old genmake.  The "DISABLE_*" flags  #  Build MNC templates and check for ability to build and use NetCDF
1253  #  need to be replaced by the "ALLOW_*" flags set below.  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1254  #  RETVAL=$?
1255  # echo -n "  Setting package-specific CPP flags:  "  if test "x$RETVAL" = x0 ; then
1256  # pkrm=( mom_fluxform mom_vecinv generic_advdiff )      ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1257  # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )      RETVAL=$?
1258  # echo -n "  "      if test "x${RETVAL}" = x0 ; then
1259  # i=0          rm -f make_mnc.errors
1260  # while test $i -lt "${#pkrm[@]}" ; do      else
1261  #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1          echo "Error: problem encountered while building source files in pkg/mnc:"
1262  #     RETVAL=$?          cat make_mnc.errors 1>&2
1263  #     if test "x$RETVAL" = x1 ; then          exit 1
1264  #       DEFINES="$DEFINES ${pkdef[$i]}"      fi
1265  #       echo -n " ${pkdef[$i]}"      if test "x$HAVE_NETCDF" != xt ; then
1266  #     fi          cat <<EOF
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
1267    
1268  echo "  Setting package-specific CPP flags in CPP_OPTIONS.h:"  WARNING: the "mnc" package has been enabled but tests failed to
1269  CPP_OPTIONS=    compile and/or execute NetCDF applications.  Please check that:
1270  spaths="$SOURCEDIRS"  
1271  for i in $spaths ; do    1) NetCDF is installed for your compiler and
1272      try="$i/CPP_OPTIONS.h"    2) the LIBS variable (within the 'optfile") specifies the correct
1273      #  echo -n "    trying $try : "         NetCDF library to link against.
1274      if test -f $try -a -r $try ; then    
1275          echo "    found CPP_OPTIONS=\"$try\""  EOF
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
1276      fi      fi
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
1277  fi  fi
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please edit  
 C  them only if you know what you're doing.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
1278    
1279  C  Packages disabled by genmake:  # Create a list of #define and #undef to enable/disable packages
1280  EOF  PACKAGES_DOT_H=PACKAGES_CONFIG.h
1281  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1282  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1283  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1284  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1285  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1286  all_pack=  all_pack=
1287    DISABLED_PACKAGES=
1288  for n in $names ; do  for n in $names ; do
1289      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1290          has_pack="f"          has_pack="f"
# Line 713  for n in $names ; do Line 1295  for n in $names ; do
1295              fi              fi
1296          done          done
1297          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1298              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1299              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1300          fi          fi
1301      fi      fi
1302  done  done
1303  cat <<EOF >>CPP_OPTIONS.h.tmp  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1304  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1305      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1306      echo "#define $def" >> CPP_OPTIONS.h.tmp      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1307    #eh3 DEFINES="$DEFINES -D$def"
1308    
1309  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1310      case $i in      case $i in
1311          aim_v23)          aim_v23)
1312              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1313                echo "Warning: ALLOW_AIM is set to enable aim_v23."
1314              ;;              ;;
1315      esac      esac
1316  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1317    
1318  done  done
 mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  
1319    
1320  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1321  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1322  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1323  for d in $STANDARDDIRS ; do      STANDARDDIRS="eesupp model"
1324      adr="$ROOTDIR/$d/src"  fi
1325      if test ! -d $adr ; then  if test "x$STANDARDDIRS" != x ; then
1326          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""      for d in $STANDARDDIRS ; do
1327          echo "  is correct and that you correctly specified the STANDARDDIRS option"          adr="$ROOTDIR/$d/src"
1328          exit 1          if test ! -d $adr ; then
1329      else              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1330          SOURCEDIRS="$SOURCEDIRS $adr"              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1331      fi              exit 1
1332      adr="$ROOTDIR/$d/inc"          else
1333      if test ! -d $adr ; then              SOURCEDIRS="$SOURCEDIRS $adr"
1334          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          fi
1335          echo "  is correct and that you correctly specified the STANDARDDIRS option"          adr="$ROOTDIR/$d/inc"
1336          exit 1          if test ! -d $adr ; then
1337      else              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1338          INCLUDEDIRS="$INCLUDEDIRS $adr"              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1339                exit 1
1340            else
1341                INCLUDEDIRS="$INCLUDEDIRS $adr"
1342            fi
1343        done
1344    fi
1345    
1346    echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1347    echo "    of \"#define \"-type statements that are no longer allowed:"
1348    CPP_OPTIONS=
1349    CPP_EEOPTIONS=
1350    spaths=". $INCLUDEDIRS"
1351    names=`ls -1 "$ROOTDIR/pkg"`
1352    for i in $spaths ; do
1353        try="$i/CPP_OPTIONS.h"
1354        if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
1355            echo "    found CPP_OPTIONS=\"$try\""
1356            CPP_OPTIONS="$try"
1357            # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1358            for n in $names ; do
1359                test_for_package_in_cpp_options $CPP_OPTIONS $n
1360            done
1361        fi
1362        try="$i/CPP_EEOPTIONS.h"
1363        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1364            echo "    found CPP_EEOPTIONS=\"$try\""
1365            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1366    #**** not yet enabled ****
1367    #        test_for_mpi_in_cpp_eeoptions $try
1368    #**** not yet enabled ****
1369            CPP_EEOPTIONS="$try"
1370      fi      fi
1371  done  done
1372    if test "x$CPP_OPTIONS" = x ; then
1373        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1374        exit 1
1375    fi
1376    
1377    #  Here, we build the list of files to be "run through" the adjoint
1378    #  compiler.
1379    if test -f ./ad_files ; then
1380        rm -f ./ad_files
1381    fi
1382    echo "  Creating the list of files for the adjoint compiler."
1383    for i in $SOURCEDIRS ; do
1384        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1385        for j in $list_files ; do
1386            cat $i/$j >> ad_files
1387        done
1388    done
1389    
1390    
1391  echo  echo
1392  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1393  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1394  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1395      if test -d $i ; then      if ! test -d $i ; then
1396          INCLUDES="$INCLUDES -I$i"  #       INCLUDES="$INCLUDES -I$i"
1397      else  #   else
1398          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1399      fi      fi
1400  done  done
# Line 798  echo -n 'SRCFILES = '    > srclist.inc Line 1408  echo -n 'SRCFILES = '    > srclist.inc
1408  echo -n 'CSRCFILES = '   > csrclist.inc  echo -n 'CSRCFILES = '   > csrclist.inc
1409  echo -n 'F90SRCFILES = ' > f90srclist.inc  echo -n 'F90SRCFILES = ' > f90srclist.inc
1410  echo -n 'HEADERFILES = ' > hlist.inc  echo -n 'HEADERFILES = ' > hlist.inc
1411  alldirs=". $SOURCEDIRS $INCLUDEDIRS"  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1412    alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1413  for d in $alldirs ; do  for d in $alldirs ; do
1414      deplist=      deplist=
1415      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1416      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1417      for sf in $sfiles ; do      for sf in $sfiles ; do
1418          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1419              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1420                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  case $d/$sf in
1421                  touch .links.tmp/$sf                    ./$PACKAGES_DOT_H)
1422                  deplist="$deplist $sf"                          ;;
1423                      ./AD_CONFIG.h)
1424                            ;;
1425                      ./FC_NAMEMANGLE.h)
1426                            ;;
1427                      *)
1428                            touch .links.tmp/$sf
1429                            deplist="$deplist $sf"
1430                            ;;
1431                    esac
1432                    extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1433                  case $extn in                  case $extn in
1434                      F)                      F)
1435                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
# Line 826  for d in $alldirs ; do Line 1447  for d in $alldirs ; do
1447                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1448                          echo -n " $sf" >> hlist.inc                          echo -n " $sf" >> hlist.inc
1449                          ;;                          ;;
1450                        flow)
1451                            echo    " \\"  >> ad_flow_files.inc
1452                            echo -n " $sf" >> ad_flow_files.inc
1453                            ;;
1454                  esac                  esac
1455              fi              fi
1456          fi          fi
# Line 842  echo "" >> srclist.inc Line 1467  echo "" >> srclist.inc
1467  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1468  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1469  echo "" >> hlist.inc  echo "" >> hlist.inc
1470    echo "" >> ad_flow_files.inc
1471    
1472  if test -e $MAKEFILE ; then  if test -e $MAKEFILE ; then
1473      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 855  echo "# by the command:" >> $MAKEFILE Line 1481  echo "# by the command:" >> $MAKEFILE
1481  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $@" >> $MAKEFILE
1482  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1483  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1484    
1485    EXE_AD=$EXECUTABLE"_ad"
1486    EXE_FTL=$EXECUTABLE"_ftl"
1487    EXE_SVD=$EXECUTABLE"_svd"
1488    
1489  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1490    #
1491    # OPTFILE="$OPTFILE"
1492  #  #
1493  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1494  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 883  EXEDIR      = ${EXEDIR} Line 1516  EXEDIR      = ${EXEDIR}
1516  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1517  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1518    
1519    #eh3  new defines for the adjoint work
1520    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1521    EXE_AD      = ${EXE_AD}
1522    EXE_FTL     = ${EXE_FTL}
1523    EXE_SVD     = ${EXE_SVD}
1524    
1525    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1526    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1527    
1528    # These files are created by Makefile
1529    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1530    
1531  EOF  EOF
1532    
1533  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 928  MAKEFILE=${MAKEFILE} Line 1573  MAKEFILE=${MAKEFILE}
1573    
1574  EOF  EOF
1575    
1576  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1577  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1578  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1579  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1580    cat ad_flow_files.inc >> $MAKEFILE
1581    echo               >> $MAKEFILE
1582  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1583  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1584  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1585    
1586  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1587    rm -f ad_flow_files.inc
1588    
1589  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1590    
# Line 944  cat >>$MAKEFILE <<EOF Line 1592  cat >>$MAKEFILE <<EOF
1592  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1593    
1594  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1595  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1596            @echo Creating \$@ ...
1597          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1598  depend:  depend:
1599          @make links          @make links
1600          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1601          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1602    
1603  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1604    
1605  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1606    
# Line 960  output.txt: \$(EXECUTABLE) Line 1609  output.txt: \$(EXECUTABLE)
1609          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1610    
1611  clean:  clean:
1612          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
1613  Clean:  Clean:
1614          @make clean          @make clean
1615          @make cleanlinks          @make cleanlinks
1616          -rm -f Makefile.bak          -rm -f \$(SPECIAL_FILES)
1617            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1618  CLEAN:  CLEAN:
1619          @make Clean          @make Clean
1620          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1621          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1622          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1623          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt
1624    
1625    #eh3 Makefile: makefile
1626  makefile:  makefile:
1627          ${0} $@          $THIS_SCRIPT $@
1628  cleanlinks:  cleanlinks:
1629          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1630    
1631    # Special targets ($SPECIAL_FILES) which are create by make
1632    ${PACKAGES_DOT_H}:
1633            @echo Creating \$@ ...
1634            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1635    AD_CONFIG.h:
1636            @echo Creating \$@ ...
1637            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1638    FC_NAMEMANGLE.h:
1639            @echo Creating \$@ ...
1640            echo "$FC_NAMEMANGLE" > \$@
1641    
1642  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1643  .F.f:  .F.f:
1644          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 995  cleanlinks: Line 1657  cleanlinks:
1657  .p.f:  .p.f:
1658          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1659    
1660    #=========================================
1661    #===  Automatic Differentiation Rules  ===
1662    
1663    TAMC           = ${TAMC}
1664    TAF            = ${TAF}
1665    
1666    TAF_EXTRA      = ${TAF_EXTRA}
1667    TAMC_EXTRA     = ${TAMC_EXTRA}
1668    
1669    EOF
1670    
1671    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1672    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1673    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1674    for i in $ad_vars ; do
1675        name=$i
1676        t1="t2=\$"`echo $i`
1677        eval $t1
1678        printf "%-20s = " $name >> $MAKEFILE
1679        echo $t2 >> $MAKEFILE
1680    done
1681    
1682    echo "  Add the source list for AD code generation"
1683    echo >> $MAKEFILE
1684    echo -n "AD_FILES = " >> $MAKEFILE
1685    AD_FILES=`cat ad_files`
1686    for i in $AD_FILES ; do
1687        echo    " \\" >> $MAKEFILE
1688        echo -n " $i" >> $MAKEFILE
1689    done
1690    echo >> $MAKEFILE
1691    rm -f ad_files
1692    
1693    cat >>$MAKEFILE <<EOF
1694    
1695    # ... AD ...
1696    adall: ad_taf
1697    adtaf: ad_taf_output.f
1698    adtamc: ad_tamc_output.f
1699    
1700    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1701            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1702            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1703            -rm -f ad_config.template
1704            @make \$(F77FILES)
1705            @make \$(AD_FLOW_FILES)
1706            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1707    
1708    ad_taf_output.f: ad_input_code.f
1709            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1710            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1711    
1712    adtafonly:
1713            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1714            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1715    
1716    ad_taf: ad_taf_output.o \$(OBJFILES)
1717            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1718    
1719    ad_tamc_output.f: ad_input_code.f
1720            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1721            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1722    
1723    ad_tamc: ad_tamc_output.o \$(OBJFILES)
1724            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1725    
1726    
1727    # ... FTL ...
1728    ftlall: ftl_taf
1729    ftltaf: ftl_taf_output.f
1730    ftltamc: ftl_tamc_output.f
1731    
1732    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1733            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1734            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1735            -rm -f ftl_config.template
1736            @make \$(F77FILES)
1737            @make \$(AD_FLOW_FILES)
1738            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1739    
1740    ftl_taf_output.f: ftl_input_code.f
1741            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1742            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1743    
1744    ftltafonly:
1745            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1746            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1747    
1748    ftl_taf: ftl_taf_output.o \$(OBJFILES)
1749            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1750    
1751    ftl_tamc_output.f: ftl_input_code.f
1752            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1753            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1754    
1755    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1756            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1757    
1758    
1759    # ... SVD ...
1760    svdtaf: ad_taf_output.f ftl_taf_output.f
1761    svdall: svd_taf
1762    
1763    svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1764            \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
1765    
1766    
1767    #=========================================
1768    
1769  EOF  EOF
1770    
1771  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1031  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1802  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1802    
1803  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1804    
1805    # Create special header files
1806    $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1807    if test ! -f $PACKAGES_DOT_H ; then
1808        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1809    else
1810        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1811        RETVAL=$?
1812        if test "x$RETVAL" = x0 ; then
1813            rm -f $PACKAGES_DOT_H".tmp"
1814        else
1815            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1816            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1817        fi
1818    fi
1819    if test ! -f AD_CONFIG.h ; then
1820        $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1821    fi
1822    
1823    
1824  #  Write the "state" for future records  #  Write the "state" for future records
1825  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1826      echo -n "" > gm_state      echo -n "" > genmake_state
1827      for i in $gm_state ; do      for i in $gm_state ; do
1828          t1="t2=\$$i"          t1="t2=\$$i"
1829          eval $t1          eval $t1
1830          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
1831      done      done
1832  fi  fi

Legend:
Removed from v.1.7  
changed lines
  Added in v.1.67

  ViewVC Help
Powered by ViewVC 1.1.22